﻿using NLog;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace Simano
{
    /// <summary>
    /// App.xaml 的互動邏輯
    /// </summary>
    public partial class App : Application
    {
        public App() :base()
        {
            Encoding.RegisterProvider(CodePagesEncodingProvider.Instance);
            InitNlog();
        }

        private void InitNlog()
        {
            var config = new NLog.Config.LoggingConfiguration();

            // Targets where to log to: File
            var logfile = new NLog.Targets.FileTarget("logfile") { FileName = "log.txt" , MaxArchiveFiles = 10 ,ArchiveEvery = NLog.Targets.FileArchivePeriod.Day };

            // Rules for mapping loggers to targets
            config.AddRule(LogLevel.Trace, LogLevel.Fatal, logfile);

            // Apply config           
            NLog.LogManager.Configuration = config;
        }
    }
}
