﻿using Newtonsoft.Json.Converters;
using Newtonsoft.Json;
using Simano.Model;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Simano
{
    public static class AppSettingConfig
    {
        private static AppSettingConfigModel _Instance;
        public static AppSettingConfigModel Instance
        {
            get
            {
                if (_Instance == null)
                {
                    Reload();
                }
                return _Instance;
            }
            private set => _Instance = value;
        }
        public static void Save()
        {
            File.WriteAllText(
                settingFilPath,
                JsonConvert.SerializeObject(
                    Instance,
                    Formatting.Indented,
                    new StringEnumConverter()
                    ));
        }

        public static void Reload()
        {
            //Instance = new AppSettingConfig();

            if (!File.Exists(settingFilPath))
            {
                LoadDefaultSetting();
            }
            else
            {
                LoadSettingFromDefaultFile();
            }
        }

        private static string settingFileName = "config.ini";
        private static string settingFilPath => Path.GetFullPath(settingFileName);

        private static void LoadDefaultSetting()
        {
            _Instance = new AppSettingConfigModel()
            {
                PortName = string.Empty,
                FirmwarePath = string.Empty,
            };
        }
        private static void LoadSettingFromDefaultFile()
        {
            try
            {
                LoadDefaultSetting();

                var configStr = File.ReadAllText(settingFilPath);
                var config = Newtonsoft.Json.JsonConvert.DeserializeObject<AppSettingConfigModel>(configStr);

                _Instance = config;
            }
            catch
            {

            }
        }
    }
}
