﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;

namespace Simano.Model
{
    public static class AesEncoder
    {
        public static byte[] GetAesEncoded(byte[] rawBytes)
        {
            AES_Cipher(rawBytes);
            return rawBytes;
        }

        //private static byte[] Bylocal(byte[] rawBytes)
        //{
        //    using (Aes aesAlg = Aes.Create())
        //    {
        //        aesAlg.CreateEncryptor()
        //    }
        //}

        private const int M_CLR = 0;

        private const int M_AES_NB = 4;
        private const int M_AES_NBb = 16;
        private const int M_AES_NK = 4;
        private const int M_AES_NR = 10;

        private const int M_AES_KEY_SIZE = 44;
        private const int M_AES_BOX_SIZE = 256;
        private const int M_AES_ROUND_CONSTANT_WORD_ARRAY = 10;

        private const int E_AES_DATA_POS_1 = 0;
        private const int E_AES_DATA_POS_2 = 1;
        private const int E_AES_DATA_POS_3 = 2;
        private const int E_AES_DATA_POS_4 = 3;
        private const int E_AES_DATA_POS_MAX = 4;

        private static UInt32[] s_aes_round_key = new UInt32[M_AES_KEY_SIZE];

        private static byte[] sc_aes_sbox = new byte[M_AES_BOX_SIZE]
        {
            0x63,0x7c,0x77,0x7b,0xf2,0x6b,0x6f,0xc5,0x30,0x01,0x67,0x2b,0xfe,0xd7,0xab,0x76,
            0xca,0x82,0xc9,0x7d,0xfa,0x59,0x47,0xf0,0xad,0xd4,0xa2,0xaf,0x9c,0xa4,0x72,0xc0,
            0xb7,0xfd,0x93,0x26,0x36,0x3f,0xf7,0xcc,0x34,0xa5,0xe5,0xf1,0x71,0xd8,0x31,0x15,
            0x04,0xc7,0x23,0xc3,0x18,0x96,0x05,0x9a,0x07,0x12,0x80,0xe2,0xeb,0x27,0xb2,0x75,
            0x09,0x83,0x2c,0x1a,0x1b,0x6e,0x5a,0xa0,0x52,0x3b,0xd6,0xb3,0x29,0xe3,0x2f,0x84,
            0x53,0xd1,0x00,0xed,0x20,0xfc,0xb1,0x5b,0x6a,0xcb,0xbe,0x39,0x4a,0x4c,0x58,0xcf,
            0xd0,0xef,0xaa,0xfb,0x43,0x4d,0x33,0x85,0x45,0xf9,0x02,0x7f,0x50,0x3c,0x9f,0xa8,
            0x51,0xa3,0x40,0x8f,0x92,0x9d,0x38,0xf5,0xbc,0xb6,0xda,0x21,0x10,0xff,0xf3,0xd2,
            0xcd,0x0c,0x13,0xec,0x5f,0x97,0x44,0x17,0xc4,0xa7,0x7e,0x3d,0x64,0x5d,0x19,0x73,
            0x60,0x81,0x4f,0xdc,0x22,0x2a,0x90,0x88,0x46,0xee,0xb8,0x14,0xde,0x5e,0x0b,0xdb,
            0xe0,0x32,0x3a,0x0a,0x49,0x06,0x24,0x5c,0xc2,0xd3,0xac,0x62,0x91,0x95,0xe4,0x79,
            0xe7,0xc8,0x37,0x6d,0x8d,0xd5,0x4e,0xa9,0x6c,0x56,0xf4,0xea,0x65,0x7a,0xae,0x08,
            0xba,0x78,0x25,0x2e,0x1c,0xa6,0xb4,0xc6,0xe8,0xdd,0x74,0x1f,0x4b,0xbd,0x8b,0x8a,
            0x70,0x3e,0xb5,0x66,0x48,0x03,0xf6,0x0e,0x61,0x35,0x57,0xb9,0x86,0xc1,0x1d,0x9e,
            0xe1,0xf8,0x98,0x11,0x69,0xd9,0x8e,0x94,0x9b,0x1e,0x87,0xe9,0xce,0x55,0x28,0xdf,
            0x8c,0xa1,0x89,0x0d,0xbf,0xe6,0x42,0x68,0x41,0x99,0x2d,0x0f,0xb0,0x54,0xbb,0x16
        };

        private static void AES_Cipher(byte[] ptr_data)
        {
            byte i, j;
            UInt32[] data = new UInt32[M_AES_NB];

            data[E_AES_DATA_POS_1] = (((UInt32)ptr_data[3] << 24) | ((UInt32)ptr_data[2] << 16) | ((UInt32)ptr_data[1] << 8) | (UInt32)ptr_data[0]);
            data[E_AES_DATA_POS_2] = (((UInt32)ptr_data[7] << 24) | ((UInt32)ptr_data[6] << 16) | ((UInt32)ptr_data[5] << 8) | (UInt32)ptr_data[4]);
            data[E_AES_DATA_POS_3] = (((UInt32)ptr_data[11] << 24) | ((UInt32)ptr_data[10] << 16) | ((UInt32)ptr_data[9] << 8) | (UInt32)ptr_data[8]);
            data[E_AES_DATA_POS_4] = (((UInt32)ptr_data[15] << 24) | ((UInt32)ptr_data[14] << 16) | ((UInt32)ptr_data[13] << 8) | (UInt32)ptr_data[12]);

            AES_AddRoundKey(data, 0);

            for (i = 1; i < M_AES_NR; i++)
            {
                AES_SubBytes(data);

                AES_ShiftRows(data);

                AES_MixColumns(data);

                AES_AddRoundKey(data, (UInt32)i);
            }

            AES_SubBytes(data);
            AES_ShiftRows(data);
            AES_AddRoundKey(data, (UInt32)i);

            for (i = 0; i < 4; i++)
            {
                for (j = 0; j < 4; j++)
                {
                    ptr_data[4 * i + j] = (byte)(((UInt32)data[i] >> (8 * j)) & 0x000000FF);
                }
            }
        }

        private static void AES_AddRoundKey(UInt32[] data, UInt32 n)
        {
            byte i;

            for (i = M_CLR; i < M_AES_NB; i++)
            {
                data[i] ^= s_aes_round_key[i + (M_AES_NB * n)];
            }
        }

        private static unsafe void AES_SubBytes(UInt32[] data)
        {
            int i;
            int j;

            fixed (UInt32* ptr = data)
            {
                byte* ptr_cb;
                ptr_cb = (byte*)ptr;
                for (i = M_CLR; i < M_AES_NBb; i = i + 4)
                {
                    for (j = M_CLR; j < (byte)4; j++)
                    {
                        ptr_cb[i + j] = sc_aes_sbox[ptr_cb[i + j]];
                    }
                }
            }
        }

        private static unsafe void AES_ShiftRows(UInt32[] data)
        {
            UInt32 i;
            UInt32 j;
            UInt32 i4;
            byte* cb;
            byte[] cw = new byte[M_AES_NBb];

            fixed (UInt32* ptr = data)
            {
                cb = (byte*)ptr;

                for (i = 0; i < M_AES_NBb; i++)
                {
                    cw[i] = cb[i];
                }

                for (i = 0; i < M_AES_NB; i += 4)
                {
                    i4 = i * 4;
                    for (j = 1; j < 4; j++)
                    {
                        cw[i4 + j + 0 * 4] = cb[i4 + j + ((j + 0) & 3) * 4];
                        cw[i4 + j + 1 * 4] = cb[i4 + j + ((j + 1) & 3) * 4];
                        cw[i4 + j + 2 * 4] = cb[i4 + j + ((j + 2) & 3) * 4];
                        cw[i4 + j + 3 * 4] = cb[i4 + j + ((j + 3) & 3) * 4];
                    }
                }

                for (i = 0; i < M_AES_NBb; i++)
                {
                    cb[i] = cw[i];
                }
            }
        }

        private static unsafe void AES_MixColumns(UInt32[] dataIn)
        {
            UInt32 i;
            UInt32 i4;
            UInt32 data1;
            UInt32 data2;
            UInt32 data3;
            UInt32 data4;
            UInt32 x;

            fixed (UInt32* data = dataIn)
            {
                //byte* data = (byte*) ptr;
                for (i = (UInt32)M_CLR; i < (UInt32)M_AES_NB; i++)
                {
                    i4 = (i * (UInt32)4);
                    data1 = ((byte*)data)[i4 + (UInt32)0];
                    data2 = ((byte*)data)[i4 + (UInt32)1];
                    data3 = ((byte*)data)[i4 + (UInt32)2];
                    data4 = ((byte*)data)[i4 + (UInt32)3];
                    x = (AES_Mul(data1, (UInt32)2) ^ AES_Mul(data2, (UInt32)3) ^ AES_Mul(data3, (UInt32)1) ^ AES_Mul(data4, (UInt32)1));
                    x |= (AES_Mul(data2, (UInt32)2) ^ AES_Mul(data3, (UInt32)3) ^ AES_Mul(data4, (UInt32)1) ^ AES_Mul(data1, (UInt32)1)) << 8;
                    x |= (AES_Mul(data3, (UInt32)2) ^ AES_Mul(data4, (UInt32)3) ^ AES_Mul(data1, (UInt32)1) ^ AES_Mul(data2, (UInt32)1)) << 16;
                    x |= (AES_Mul(data4, (UInt32)2) ^ AES_Mul(data1, (UInt32)3) ^ AES_Mul(data2, (UInt32)1) ^ AES_Mul(data3, (UInt32)1)) << 24;

                    data[i] = x;
                }
            }
                
        }

        private static UInt32 AES_Mul(UInt32 data, UInt32 n)
        {
            UInt32 i;
            UInt32 x;

            x = 0;
            for (i = (UInt32)8; i > (UInt32)0; i = i / (UInt32)2)
            {
                x = x * (UInt32)2;
                if (M_CLR != (x & (UInt32)0x0100))
                {
                    x = (x ^ (UInt32)0x001B) & (UInt32)0x00FF;
                }
                if (M_CLR != (n & i))
                {
                    x = x ^ data;
                }
            }
            return x;
        }
    }
}
