﻿using NLog;
using Simano.Service.Adapter;
using Simano.Service.CubeProgrammerAPI;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;

namespace Simano.UserControls
{
    /// <summary>
    /// STCubeTestPanel.xaml 的互動邏輯
    /// </summary>
    public partial class STCubeTestPanel : UserControl
    {
        public STCubeTestPanel()
        {
            InitializeComponent();

            Init();
        }
        private static readonly NLog.Logger Logger = NLog.LogManager.GetCurrentClassLogger();

        private void Init()
        {
            CubeProgrammerAPIAdapter.OnLogReceived += CubeProgrammerAPIAdapter_OnLogReceived;
            CubeProgrammerAPIAdapter.Init();
        }

        private void CubeProgrammerAPIAdapter_OnLogReceived(object sender, string e)
        {
            Logger.Trace(e);
            uxConsole.AppendText(e + Environment.NewLine);
        }

        private void GetComListButton_Click(object sender, RoutedEventArgs e)
        {
            //var downloadResult = CubeProgrammerAPIAdapter.DownloadFile("", 0x08000000);

            var list = CubeProgrammerAPIAdapter.GetUsartList();
            foreach (var comName in list)
            {
                uxConsole.AppendText(comName + Environment.NewLine);
            }
        }

        private async void OpenPortTestButton_Click(object sender, RoutedEventArgs e)
        {
            var openPortResult = await CubeProgrammerAPIWrapper.OpenPort(uxPortName.Text);
            if (openPortResult)
            {
                uxConsole.AppendText($"Open port failed({openPortResult})" + Environment.NewLine);
                return;
            }
            uxConsole.AppendText("Open port Success" + Environment.NewLine);
        }

        private void DownloadButton_Click(object sender, RoutedEventArgs e)
        {
            var path = Path.GetFullPath("./C071_LED_BUTTON_B0.bin");
            var address = 0x08008000u;
            var result = CubeProgrammerAPIWrapper.DownloadFile(path, address);
            uxConsole.AppendText($"DownloadFile Result :{result}" + Environment.NewLine);
        }

        private void DisconnectButton_Click(object sender, RoutedEventArgs e)
        {
            CubeProgrammerAPIAdapter.ClosePort();
        }
    }
}
